#ifndef FILES_H
#define FILES_H

#include <vector>

#ifdef _WIN32
#define SEPARATOR '\\'
#else
#define SEPARATOR '/'
#endif


class FileRef
{
public:
	FileRef(char *n = NULL, int s = 0) : name(n), size(s) {}

	char *name;
	int size;
	//...flags, date etc
};

class IFileList
{
public:

	virtual ~IFileList() {}

	virtual int Read(int index, char *dest, int offset, int length) = 0;
	virtual const char *GetFileName(int index) = 0;
	virtual std::vector<FileRef> &GetNames() = 0;
	virtual int Enter(int index) = 0;

	virtual void SetFilterFunc(int (*fcb)(const char *)) = 0;

};

#endif
