#ifndef MUSIC_PLAYER_H
#define MUSIC_PLAYER_H

#include <vector>
#include "plugin.h"

class BlockFifo;

extern struct sound_plugin *current_plugin;

class MusicPlayer
{
public:
	MusicPlayer();

	bool PlaySong(const char *fname);
	bool PlaySong(const char *name, char *data, int size);

	int Pause();

	int GetMaxTunes() { return (current_plugin ? current_plugin->subtunes : -1); }
	int GetTune() {  return subtune; }

	void SetTune(int n);
	void SetVolume(int v);
	int GetVolume() { return vol; }

	int GetCSeconds() { return total_samples / 8820; }

	const char *GetName() {  return (current_plugin ? current_plugin->name : ""); }
	const char *GetArtist() {  return (current_plugin ? current_plugin->artist : ""); }
	const char *GetCopyright() {  return (current_plugin ? current_plugin->copyright : ""); }
	const char *GetFormat() {  return (current_plugin ? current_plugin->format : ""); }

	int GetLength() { return (current_plugin ? current_plugin->length / 1000 : -1); }

	int CanHandle(const char *name);

	int GetNextSamples(short *dest, int len);

	void SetBlend(int b)
	{ 
		if(b < 0)
			b = 0;
		if(b > 255)
			b = 255;
		blend = b;
	}

	int GetBlend() { return blend; }

	int GetHeavy() { return heavy; }

protected:

	static void audio_cb(void *userdata, Uint8 *stream, int len);
	static void fill_audio(BlockFifo *af, int max);


	std::vector<sound_plugin*> sound_plugins;
	
	//struct sound_plugin *current_plugin;

	int subtune;
	//int maxtune;
	//int last_tune;
	int vol;
	int total_samples;
	//int lastvol;
	BlockFifo *audioFifo;

	int blend;
	int heavy;

	char temp_name[64];

	int InitSound();

};

#endif
