#ifndef ZIPFILELIST_H
#define ZIPFILELIST_H

#include "Files.h"

struct zip;

class ZipDir;

class ZipFileList : public IFileList
{
public:

	ZipFileList(char *source);
	virtual ~ZipFileList();

	virtual int Read(int index, char *dest, int offset, int length);
	virtual const char *GetFileName(int index);
	virtual std::vector<FileRef> &GetNames();
	virtual int Enter(int index);

	virtual void SetFilterFunc(int (*fcb)(const char *))
	{
		printf("Setting %p %p\n", filter_cb, &filter_cb);
		filter_cb = fcb;
	}

protected:

	int (*filter_cb)(const char *);

	std::vector<FileRef> filerefs;

	bool dirty;
	ZipDir *curdir;

	struct zip *zipf;
	int count;
	int dircount;


	void Enter(char *dirname);

};

#endif
