#include <stdio.h>
#include <string.h>
#include <modplug.h>

#include "plugin.h"

static struct sound_plugin plugin;

static ModPlugFile *mpfile = NULL;

static int init_data(char *name, void *data, int size)
{
	if(mpfile)
	    ModPlug_Unload(mpfile);

	ModPlug_Settings settings;
    ModPlug_GetSettings(&settings);

	settings.mResamplingMode = MODPLUG_RESAMPLE_FIR; /* RESAMP */
	settings.mChannels = 2;
	settings.mBits = 16;
	settings.mFrequency = 22050;
    /* insert more setting changes here */
	ModPlug_SetSettings(&settings);

	mpfile = ModPlug_Load(data, size);


	plugin.name = (char *)ModPlug_GetName(mpfile);
	plugin.author = "";
	return 0;
}

static int fill_buffer(signed short *dest, int len)
{
	if(mpfile)
		ModPlug_Read(mpfile, dest, len);
	else
		memset(dest, 0, len);

	return 0;
}

static int is_ext(const char *s, const char *ext)
{
	const char *sext = strrchr(s, '.');
	if(!sext)
		sext = "";
	return (stricmp(ext, sext) == 0);
}

static int can_handle(const char *name)
{
	return (is_ext(name, ".mod"));
}

struct sound_plugin *init_sound2_plugin()
{
	memset(&plugin, 0, sizeof(plugin));

	plugin.freq = 22050;
	plugin.channels = 2;
	//plugin.init_file = init_file;
	plugin.init_data = init_data;
	plugin.fill_buffer = fill_buffer;
	plugin.can_handle = can_handle;
	//plugin.set_position = set_position;

	return &plugin;
}

