TARGET = oldplay

# Flags for a static build - TODO: Support dynamic linked plugins

CFLAGS += -I../include \
          -I../include/gme \
          -I../include/libsidplay \
          -I../include/modplug \
          -I../include/uade \
          -g \
          `$(PREFIX)sdl-config --cflags` \
          -DPATH_MAX=4096 \
          -DFB16 \
          -DOLDPLAYVERSION="\"v0.99a sasq+micket\""

LIBS += -L../libs \
        -lsidplay \
        -luade \
        -lmad \
        -lgme \
        -lpokecubed \
        -lmodplug \
        -lid3tag \
        -lz \
        -lzip \
        `$(PREFIX)sdl-config --libs`

OBJS += main.o util.o \
        Config.o Hashtable.o \
        PlayerApp.o MusicPlayer.o Input.o Fifo.o SDLScreen.o Equalizer.o M3uPlayList.o \
        FileList.o PlayList.o SaveList.o ZipFileList.o \
        BrowserState.o PlayListState.o SaveState.o

MODULES += pogo fft uadeplugin madplugin sidplugin modplugin gmeplugin pokecubedplugin

############################## NORMALLY DONT TOUCH ANYTHING BELOW ###########################

LD   = $(PREFIX)g++
CC   = $(PREFIX)gcc
CXX  = $(PREFIX)g++

# Implicit rules

$(OBJDIR)/%.o : %.c
	$(CC) -c $(CFLAGS) $< -o $@

$(OBJDIR)/%.o : %.cpp
	$(CXX) -c $(CFLAGS) $< -o $@

$(OBJDIR)/%.o : %.S
	$(AS) $(ASFLAGS) $< -o $@

$(OBJDIR)/%.o : %.s
	$(AS) $(ASFLAGS) $< -o $@
	
$(OBJDIR)/% :
	mkdir -p $@
	
CFLAGS += $(addprefix -I,$(MODULES))

MODULEOBJS = $(patsubst %.cpp,%.o, $(wildcard $(addsuffix /*.cpp,$(MODULES))))
MODULEOBJS += $(patsubst %.c,%.o, $(wildcard $(addsuffix /*.c,$(MODULES))))

OBJFILES = $(addprefix $(OBJDIR)/,$(OBJS) $(MODULEOBJS))
OBJDIRS = $(OBJDIR) $(addprefix $(OBJDIR)/, $(MODULES))

all : $(OBJDIRS) $(OBJFILES) $(TARGET)$(EXT) 

$(OBJDIR) :
	mkdir -p $(OBJDIR)

$(TARGET)$(EXT) : $(OBJFILES) $(DEPS)
	$(LD) $(LDFLAGS) -o $(TARGET)$(EXT) $(OBJFILES) $(LIBS)
	$(PREFIX)strip $(TARGET)$(EXT)
	mv $(TARGET)$(EXT) ../player
	
clean :
	rm -rf $(OBJFILES) $(TARGET)$(EXT)
